
Foreman - Feature #101

Add ability to view puppetdoc documentation

11/30/2009 05:56 PM - Frank Sweetser

Status: Closed   

Priority: Normal   

Assignee: Paul Kelly   

Category: Puppet integration   

Target version: 0.1-5   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

It would great if you were able to view formatted puppetdoc documentation for each class.  The ideal would be to have available the

full documentation in the Settings -> Puppet Classes page, and a shorter summary (title plus first paragraph, maybe?) on any page

where classes are associated with other entities.

Associated revisions

Revision a67b0923 - 05/28/2010 03:52 PM - Paul Kelly

Fixes #101 - Generate rdoc files and html links on the puppetclasses page

Rewite rdocs if required by the prepare phase

Incorporate Fank Sweetser's :: patch

Incorporate a url_helper suggested by Ohad

Added a new interface via links on the supported environments list

History

#1 - 12/04/2009 02:13 PM - Ohad Levy

- Category set to Puppet integration

so this seems to be "simple" if:

1. you generate a pupeptdoc per environment

2. you link directly to the class - e.g. puppetdoc_dir/classes/classname.html

3. you ignore the nodes data (hopefully you are using external nodes with foreman anyway).

so one approach would be to create another settings in configs/settings.yml and define puppetdoc_dir where:

the actual puppet doc would be at:

puppetdoc_dir/#{environment}/classes/${class}.html

any thoughts?

#2 - 12/04/2009 06:03 PM - Frank Sweetser

Sounds good to me.  Foreman is obviously most useful when used an an external node classifier, so I don't think it's entirely unfair to skip over node

docs.  Plus, if you're switching from nodes.pp over to foreman as an external node source, you already have to manually shuffle over settings and

class assignments anyway, so copying over the comments too shouldn't be a big deal.

#3 - 12/14/2009 12:21 PM - Ohad Levy

- Target version set to 0.1-4

#4 - 03/08/2010 06:04 AM - Ohad Levy

- Target version changed from 0.1-4 to 0.1-5

I'm pushing this to the next release, as I'm a bit out of time and would like to get the bug fixes out
#5 - 03/17/2010 08:21 AM - Paul Kelly

- Status changed from New to Assigned

- Assignee set to Paul Kelly

#6 - 03/17/2010 11:27 AM - Paul Kelly

- Status changed from Assigned to Feedback

There is a provisional implementation of this code on branch feature/101 on my github.

We must discuss this as it is not complete

Maybe you can answer these and other questions

1) How do you access rake's --verbose flag from within a rake task?

2) Does/Should the user have a concept of a current environment.

#7 - 03/20/2010 10:52 AM - Paul Kelly

- Status changed from Feedback to Ready For Testing

#8 - 03/25/2010 01:30 PM - Ohad Levy

- Assignee changed from Paul Kelly to Frank Sweetser

Hi,

Do you think you could test this patch?

Many thanks,

Ohad

#9 - 04/16/2010 01:14 AM - Frank Sweetser

I gave it a quick trial run today, and it looks pretty good to me.  I just had a few minor comments.

The environment selection page looks a little awkward if you have fewer than four environments.  Ideally, if you only have a single environment

(like I do) it would skip the selection page altogether and just send you to the correct page.

This is technically a puppet issue, but I wasn't able to run the document creation task until I patched puppetrun to not pass the --force-update

option to rdoc, since my version (stock centos 5.4) didn't support it.

I have my docroot pointing at foreman (it's running on a single purpose VM), so in order to make the puppetdoc output viewable I had to have

them dumped in the public directory of foreman.  This may be worth mentioning in the documentation.

Other than that, this patch gets my vote.

#10 - 04/16/2010 04:36 PM - Frank Sweetser

- File 0001-Generate-valid-doc-URLs-for-nested-classes.patch added

Found another issue - nested classes (ie, 'ntp::client') need to have the double colons turned into slashes to generate valid URLs.  Simple patch

attached.

#11 - 04/16/2010 05:03 PM - Ohad Levy

- Assignee changed from Frank Sweetser to Paul Kelly

#12 - 04/19/2010 02:58 PM - Paul Kelly

The code has been rebased against develop and now incorporates Frank Sweetser's request for a direct link to the rdocs if there is only one

environment. I have also applied his patch for the :: issue. Thanks Frank.

I will now add a page to the Wiki for this feature

#13 - 05/07/2010 04:31 PM - Paul Kelly

rebased against develop@95131ca23a6b28e295be839964f9663b0e07c559

cleaned up whitespace

set default_scope to order by name for puppetclasses

fixed tests

#14 - 05/17/2010 02:44 PM - Paul Kelly
- Status changed from Ready For Testing to Feedback

Fixed the fgrep issue and other points raised.

Ohad, do you think that the list of supported environments, on the puppetclasses page, could be replaced with a list of links rather than text. The links

could point at the documentation and be one click closer. This is different to all other controllers but might be acceptable if the column heading is

changed,

#15 - 05/28/2010 11:27 AM - Paul Kelly

- Branch set to feature/101-view-puppetdocs

Rabased

#16 - 05/28/2010 03:57 PM - Paul Kelly

- Status changed from Feedback to Ready For Testing

- % Done changed from 0 to 100

Applied in changeset a67b092319ec685ce08e4f222f9d4e0398c13297.

#17 - 05/30/2010 04:50 PM - Ohad Levy

- Status changed from Ready For Testing to Closed

Files

0001-Generate-valid-doc-URLs-for-nested-classes.patch 1.61 KB 04/16/2010 Frank Sweetser
